/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM 
    Descripción:        Clase que contiene la logica para cargar los registros que vienen del Trigger 
    					TAM_VentasCRM_handler.

    Infomación de cambios (versiones)VaRtAccRegPF
    ===============================================================================
    No.    Fecha             	Autor                       Descripcion
    1.0    25-Mayo-2020    		Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_VentasCRM_handler extends TriggerHandler{

	private List<TAM_VentasCRM__c> ventasHList;
	private Map<Id,TAM_VentasCRM__c> mapVentas;
    private Map<String,Map<String,RecordType>> recordTypesMap;

    public TAM_VentasCRM_handler(){
		this.ventasHList = Trigger.new;
		this.mapVentas = (Map<Id,TAM_VentasCRM__c>)Trigger.newMap;
        this.recordTypesMap = Constantes.TIPOS_REGISTRO_DEVNAME_ID; 
    }
    
	public override void afterInsert(){
		validateRecords(ventasHList);
		actualizaDatosLead(ventasHList);
		eliminaRecords(mapVentas);
	}

    public override void afterUpdate(){
        actualizaDatosLead(ventasHList);        
    }

	private void eliminaRecords(Map<Id,TAM_VentasCRM__c> mapVentas){
       	System.debug('EN eliminaRecords mapVentas: '+ mapVentas);		
		Set<String> vines = new Set<String>();
		for(TAM_VentasCRM__c v: mapVentas.values()){
			vines.add(v.ID);
		}
		if(vines.size() > 0){
			List<TAM_VentasCRM__c> borrar = new List<TAM_VentasCRM__c>();
			for(TAM_VentasCRM__c v : [SELECT Id, Name FROM TAM_VentasCRM__c WHERE id IN :vines]){
				borrar.add(v);
			}
       		System.debug('EN eliminaRecords borrar: '+ borrar);			
			if(borrar.size() > 0){
				//delete borrar;
                if (!Test.isRunningTest()){
					List<Database.DeleteResult> lDtbUpsRes = Database.delete(borrar, false);
					//Ve si hubo error
					for (Database.DeleteResult objDtbUpsRes : lDtbUpsRes){
						if (!objDtbUpsRes.isSuccess())
							System.debug('Error a la hora de eliminar el reg ' + objDtbUpsRes.getErrors()[0].getMessage());	
					}//Fin del for para lDtbUpsRes
                }//Fin si !Test.isRunningTest()
			}
		}
	}

	private void validateRecords(List<TAM_VentasCRM__c> ventasList){
		String sToyota = 'TOYOTA FINANCIAL SERVICES';
		String sToyotaCompleto = 'TOYOTA FINANCIAL SERVICES MEXICO SA DE CV';
				
        Map<String, Account> dealers;                            
        System.debug(JSON.serialize(mapVentas));

	    String VaRtAccRegPM = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();
    	String VaRtAccRegPF = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();

        String VaRtCtePMCorp = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();
        String VaRtCtePFCorp = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo CP').getRecordTypeId();

    	String VaRtOppRegVCrm = Schema.SObjectType.Opportunity.getRecordTypeInfosByName().get('Ventas CRM').getRecordTypeId();    	
    	String VaRtContRegPF = Schema.SObjectType.Contact.getRecordTypeInfosByName().get('Contactos-Clientes').getRecordTypeId();    	
    	String VaRtProdReg = Schema.SObjectType.Product2.getRecordTypeInfosByName().get('Unidad').getRecordTypeId();
    	String VaRtEntregado = Schema.SObjectType.Lead.getRecordTypeInfosByName().get('Entregado').getRecordTypeId();    	
    	
    	String VaRtStdPriceBookIdReg;
    	//No es una prueba
    	if (!Test.isRunningTest()) 
    		VaRtStdPriceBookIdReg =[Select p.Name, p.IsStandard, p.Id From Pricebook2 p where p.IsStandard = true].id;
    	//Es una prueba	
    	if (Test.isRunningTest())
    		VaRtStdPriceBookIdReg = Test.getStandardPricebookId();    		    	 
		String[] setMeses = new list<String>{'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'}; 
		    	
        Map<String, Vehiculo__c> vines = new Map<String, Vehiculo__c>();
        Map<String, ColorExterno__c> coloresExt = new Map<String, ColorExterno__c>();        
        Map<String, ColorInterno__c> coloresInt = new Map<String, ColorInterno__c>();
        //Obtener los colores externos e internos del archivo de ventas
        Set<String> ColorExt = new Set<String>();
        Set<String> ColorInt = new Set<String>();            
        Map<String, Product2> productos = new Map<String, Product2>();

        Map<String, SolicitudAutoDemo__c> autosDemo = new Map<String, SolicitudAutoDemo__c>();
        List<Movimiento__c> movimientos = new List<Movimiento__c>();

        Set<String> dealersCode = new Set<String>();               	
    		
		Set<String> setModelo = new Set<String>();
		map<String, Modelo__c> mapModelos = new map<String, Modelo__c>();

		Set<String> setColorExt = new Set<String>();
		map<String, ColorExterno__c> mapColorExt = new map<String, ColorExterno__c>();

		Set<String> setColorInt = new Set<String>();
		map<String, ColorInterno__c> mapColorInt = new map<String, ColorInterno__c>();

		Set<String> setIdDistribuidor = new Set<String>();
		map<String, Account> mapDistribuidores = new map<String, Account>();

    	map<String, Account> mapClientesUps = new Map<String, Account>();
		Set<String> setIdCtesCreados = new Set<String>();    	
    	map<String, String> mapIdClientesId = new Map<String, String>();

    	map<String, Contact> mapContactosUps = new Map<String, Contact>();
    	map<String, Contact> mapContactosUpsCtaPrinc = new Map<String, Contact>();
		Set<String> setIdContactCreados = new Set<String>();
		Set<String> setErroresContactosUps = new Set<String>();		    	
    	map<String, String> mapIdContactosId = new Map<String, String>();

    	map<String, AccountContactRelation> mapAccountContactRelationUps = new Map<String, AccountContactRelation>();    	
		Set<String> setErroresAccContacRelErr = new Set<String>();
		Set<String> setIdAccContacRelSucc = new Set<String>();		    	
		
		map<String, String> mapVinOppIdExtCliente = new map<String, String>();
		Set<String> setErroresAccUps = new Set<String>();

		map<String, String> mapVinOppIdExtClienteContacto = new map<String, String>();
		Set<String> setErroresAccContactUps = new Set<String>();

		map<String, Opportunity> mapOppUps = new map<String, Opportunity>();
		Set<String> setErroresOppUps = new Set<String>();
		Set<String> setIdOppUps = new Set<String>();		
		map<String, Opportunity> mapVinOppIdUps = new map<String, Opportunity>();
		Set<String> setVinOppContact = new Set<String>();
		
		map<String, OpportunityLineItem> mapOppLinItmUps = new map<String, OpportunityLineItem>();
		Set<String> setErroresOppLinItmUps = new Set<String>();
		Set<String> setOppLinItmUps = new Set<String>();		
		map<String, String> mapVinOppLinItmUps = new map<String, String>();

		Set<String> setProduct2 = new Set<String>();
        Map<String, Product2> mapProduct2 = new Map<String, Product2>();

		Set<String> setNombreListaPrecios = new Set<String>();
        Map<String, String> mapListaPrecios = new Map<String, String>();

		Set<String> setIdNomLisPre = new Set<String>();
        Map<String, PricebookEntry> mapPrecios = new Map<String, PricebookEntry>();
		                						
		Map<String, String> mapIdPerAccIdContacPrinc = new Map<String, String>();
		
		Set<String> setIdVinActCand = new Set<String>();
		map<String, Lead> mapLeadUpsUps = new map<String, Lead>();
        Set<String> setErroresLeadErr = new Set<String>();
        Set<String> setIdLeadSucc = new Set<String>();              

        map<String, TAM_LeadInventarios__c> mapLeadInvComs = new map<String, TAM_LeadInventarios__c>();
        map<String, String> mapVinNomCte = new map<String, String>();
        map<String, TAM_LeadInventarios__c> mapLeadInvUpd = new map<String, TAM_LeadInventarios__c>();

		Set<String> setIdExtAccont = new Set<String>();
		map<String, Account> mapIdExtCteIdRtAct = new map<String, Account>();
				                						
		//Recorre la lista de reg que se estan nsertando
        for(TAM_VentasCRM__c v: ventasList){	            
            //Toma el Vin para la busqueda del candidato asociado a ese vin
            if(v.Name != null)
            	setIdVinActCand.add(v.Name);
        }		
		System.debug('EN validateRecords setIdVinActCand: '+ setIdVinActCand);
		
        //Recorre la lista de reg ventasList
        for(TAM_VentasCRM__c v: ventasList){
            if(v.IdDealerCode__c != null){
                dealersCode.add(v.IdDealerCode__c);
            }
        }
        
        System.debug(dealersCode);
        dealers = AutoDemoTriggerMethods.getDealerCodeInfoMap(dealersCode);
        System.debug(JSON.serialize(dealers));

       	//Inicializa un SavePoint para hacer el rollback en caso de error
       	SavePoint svUpsDatos = Database.setSavepoint();

		//Un try para los errores
        try{
        	
        	//Recorremos los reg de ventas
        	for(TAM_VentasCRM__c v: ventasList){

                System.debug('EN validateRecords v REGISTRO: '+ v);

                Boolean bPersonaMoral = false;
                String sLlaveCompuestaNombre = '';
    	    	String[] sLlaveNombreCompuesto = new List<String>();
	    	    					
				//****** TODO ESTO PARA LOS DATOS DEL CLIENTE (ACCOUNT) *****///
	        	//Crea la llave foranea apartir de los datos del nombre del cliente
	        	//SI SE TRATA DEL TITULAR
	        	if (v.TAM_TipoCliente__c == 'Primero'){ 
 
	    	    	sLlaveNombreCompuesto = validaNombre(v.FirstName__c, v.TAM_dNEXOS1__c, v.LastName__c, v.TAM_dNEXOS2__c, v.TAM_dAPELL2__c, 
	    	    		v.TAM_RFC1__c, v.TAM_RFC2__c, v.IdExterno__c);
	    	    		
	                System.debug('EN validateRecords sLlaveNombreCompuesto: '+ sLlaveNombreCompuesto[0]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto: '+ sLlaveNombreCompuesto[1]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto: '+ sLlaveNombreCompuesto[2]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto: '+ sLlaveNombreCompuesto[3]);
	                
	                //Ve si el arreglo sLlaveNombreCompuesto tiene algo
	                if (sLlaveNombreCompuesto.size() > 2){
	                	//Ve si se trata de una persona Moral
	                	String sNombreCliente = sLlaveNombreCompuesto[0].trim();
	                	if (sNombreCliente == null || sNombreCliente == '')
	                		bPersonaMoral = true;
	                	else
	                		sLlaveCompuestaNombre += sNombreCliente + ' ';
	                	sLlaveCompuestaNombre += sLlaveNombreCompuesto[1] != null && sLlaveNombreCompuesto[1] != '' ? sLlaveNombreCompuesto[1].trim() + ' ' : '';                		 	
	                	sLlaveCompuestaNombre += sLlaveNombreCompuesto[2] != null && sLlaveNombreCompuesto[2] != '' ? sLlaveNombreCompuesto[2].trim() + ' ' : '';                	
	                }//Fin si sLlaveNombreCompuesto.size() >= 2  
					
					//Quita los espacios a los lados
					sLlaveCompuestaNombre = sLlaveCompuestaNombre.trim();
					
					//Ve si ya existe el sLlaveCompuestaNombre en el mapa de mapVinOppIdExtCliente
					mapVinOppIdExtCliente.put(v.Name + ' - ' + ( sLlaveCompuestaNombre.contains(sToyota) ? sToyotaCompleto : sLlaveCompuestaNombre), (sLlaveCompuestaNombre.contains(sToyota) ? sToyotaCompleto : sLlaveCompuestaNombre));
													
	                System.debug('EN validateRecords sLlaveNombreCompuesto: ' + sLlaveNombreCompuesto);
	                String sDireccionPaso = v.TAM_dTIPVIA__c != null && v.TAM_dTIPVIA__c != ' ' ? v.TAM_dTIPVIA__c.trim() + ' ' : ' ';
	                sDireccionPaso += v.TAM_ADDRESS_1__c != null && v.TAM_ADDRESS_1__c != ' ' ? v.TAM_ADDRESS_1__c.trim() + ' ' : ' ';
	                sDireccionPaso += v.TAM_dNUMEXT__c != null && v.TAM_dNUMEXT__c != ' ' ? v.TAM_dNUMEXT__c.trim() + ' ' : ' ';	                
	                sDireccionPaso += v.TAM_dNUMINT__c != null && v.TAM_dNUMINT__c != ' ' ? v.TAM_dNUMINT__c.trim() + ' ' : ' ';
	                //Para la calle y el codigo postal
	                String[] lDireccionPaso = sDireccionPaso.contains(';') ? sDireccionPaso.split(';') : new List<String>{sDireccionPaso};  
	                //Para la colonia
	                String sColoniaPaso = v.Address2__c != null && v.Address2__c != ' ' ? v.Address2__c.trim() + ' ' : ' '; //LISTO
	                sColoniaPaso += v.TAM_dLPOBLA__c != null && v.TAM_dLPOBLA__c != ' ' ? v.TAM_dLPOBLA__c.trim() + ' ' : ' '; //LISTO
	                sColoniaPaso += v.TAM_dRPOBLA__c != null && v.TAM_dRPOBLA__c != ' ' ? v.TAM_dRPOBLA__c.trim() + ' ' : ' '; //LISTO
	                //Para la ciudad 
	                String sCiudadPaso = v.City__c != null && v.City__c != '' ? v.City__c.trim() : '';
	                //Para el Estado 
	                String sEstadoPaso = v.State__c != null && v.State__c != '' ? v.State__c.trim() : '';
	                //Para el Código Postal 
	                String sCodigoPostalPaso = v.Zip__c != null && v.Zip__c != '' ? v.Zip__c.trim() : ''; //LISTO

	                //Para Latitud X 
	                String sdCOORGX = v.TAM_dCOORGX__c != null && v.TAM_dCOORGX__c != '' ? v.TAM_dCOORGX__c.trim() : ''; //LISTO
	                //Para Latitud Y
	                String sdCOORGY = v.TAM_dCOORGY__c != null && v.TAM_dCOORGY__c != '' ? v.TAM_dCOORGY__c.trim() : ''; //LISTO	                
	                
	                //Para el Número de Teléfono 
	                String sPhonePaso = v.TelHome__c != null && v.TelHome__c != '' ? v.TelHome__c.trim() : '';
	                //Para el Número de Teléfono del trabajo 
	                String sPhoneOfficePaso = v.TelWork__c != null && v.TelWork__c != '' ? v.TelWork__c.trim() : '';
	                //Para el Número de Teléfono del trabajo 
	                String sExtOfficePaso = v.TelWorkExt__c != null && v.TelWorkExt__c != '' ? v.TelWorkExt__c.trim() : '';
	                //Para el Correo 
	                String sEmailOfficePaso = v.Email__c != null && v.Email__c != '' ? v.Email__c.trim() : '';
	                //Para el RFC 1 
	                String sRfcPaso = v.TAM_RFC1__c != null && v.TAM_RFC1__c != '' ? v.TAM_RFC1__c.trim() : '';
	                //Para el RFC 2 
	                String sRfc2Paso = v.TAM_RFC2__c != null && v.TAM_RFC2__c != '' ? v.TAM_RFC2__c.trim() : '';
	                //Para el Genero 
	                String sGenero = v.TAM_dSEXO__c != null && v.TAM_dSEXO__c != '' ? v.TAM_dSEXO__c.trim() : '';
	                String sGeneroFinal = sGenero == 'E' ? 'Empresa' : sGenero == 'H' ? 'Masculino' : sGenero == 'M' ? 'Femenino' : null;

	                //Para el sdINDFIA 
	                String sdINDFIA = v.TAM_dINDFIA__c != null && v.TAM_dINDFIA__c != '' ? v.TAM_dINDFIA__c.trim() : '';
	                //Para el sdINDICA 
	                String sdINDICA = v.TAM_dINDICA__c != null && v.TAM_dINDICA__c != '' ? v.TAM_dINDICA__c.trim() : '';
					
	                //Crea el objeto del cliente Account                
					Account clientePaso = new Account(
						TAM_IdExternoNombre__c = sLlaveCompuestaNombre,
						TAM_CuentaPrincipal__c = dealers.containsKey(v.IdDealerCode__c) ? dealers.get(v.IdDealerCode__c).id : null,
						BillingStreet = lDireccionPaso[0].toUpperCase(),
						Colonia__c = sColoniaPaso.toUpperCase(),
						BillingCity = sCiudadPaso.toUpperCase(), 
						BillingState = sEstadoPaso.toUpperCase(),
						BillingPostalCode = sCodigoPostalPaso,
						Phone = sPhonePaso,
						Telefono_Oficina__c = sPhoneOfficePaso,
						Extension_Oficina__c = sExtOfficePaso, 
						Correo_Electronico__c = sEmailOfficePaso,
						RFC__c = sRfcPaso,
						RFC2__c = sRfc2Paso,
						BillingLongitude = sdCOORGX != '' ? Decimal.valueOf(sdCOORGX) : null,
						BillingLatitude  = sdCOORGY != '' ? Decimal.valueOf(sdCOORGY) : null,
						Geolocalizacion__Longitude__s = sdCOORGX != '' ? Decimal.valueOf(sdCOORGX) : null,
						Geolocalizacion__Latitude__s = sdCOORGY != '' ? Decimal.valueOf(sdCOORGY) : null,
						Genero__c = sGeneroFinal,
						TAM_dINDFIA__c = sdINDFIA,
						TAM_dINDICA__c = sdINDICA
	       			);
	
	                System.debug('EN validateRecords bPersonaMoral: ' + bPersonaMoral);       			
	       			//Antes de insertarla ve que tipo de cliente y ponle en tipo de reg
	       			if (bPersonaMoral){
	       				clientePaso.recordTypeId = VaRtAccRegPM;
	       				clientePaso.Name = sLlaveNombreCompuesto[1];
						clientePaso.TAM_NombreComercial__c = sLlaveNombreCompuesto[1];
						clientePaso.DenominacionSocial__c = sLlaveNombreCompuesto[1];
						clientePaso.TAM_TipoPersonaProspecto__c = 'Persona moral';
	       			}//Fin si bPersonaMoral
	       			if (!bPersonaMoral){       				 
	       				clientePaso.recordTypeId = VaRtAccRegPF;
	       				clientePaso.FirstName = sLlaveNombreCompuesto[0];
	       				clientePaso.LastName = sLlaveNombreCompuesto[1];
	       				clientePaso.Apellido_Paterno__c = sLlaveNombreCompuesto[2];
	       				clientePaso.TAM_TipoPersonaProspecto__c = 'Person física';
	       			}//Fin si !bPersonaMoral
	                System.debug('EN validateRecords clientePaso: ' + clientePaso);
	       			
	       			//Mete la llave sLlaveCompuestaNombre en otro set para consultar los datos del cliente mas adelanye
	       			setIdExtAccont.add(sLlaveCompuestaNombre);
	                System.debug('EN validateRecords setIdExtAccont: ' + setIdExtAccont);
	       			
	        		//Crea el reg para la cuenta y metelo al mapa de mapClientesUps
	        		mapClientesUps.put(sLlaveCompuestaNombre, clientePaso);
					//****** HASTA AQUI TODO ESTO PARA LOS DATOS DEL CLIENTE (ACCOUNT) *****///


					//****** TODO ESTO PARA LOS DATOS DE LA OPOTUNIDAD ASOCIADA AL CLIENTE (Opportunity) *****///
	 				//String sIdListaPrecios = mapListaPrecios.containsKey(sNombreListaPrecios) ? mapListaPrecios.get(sNombreListaPrecios) : VaRtStdPriceBookIdReg;
	 				String sIdListaPrecios = VaRtStdPriceBookIdReg;
	 					 				
	 				String sVersionProd = '';
					//Crea las opotunidades a partir del Vin de la venta y metelas el mapa de mapOppUps
					if (v.Name != null){
						String sNombreOpp = v.Name + ' - ';
						String sNomEmp = sLlaveCompuestaNombre.contains(sToyota) ? sToyotaCompleto : sLlaveCompuestaNombre;
						sNombreOpp += sVersionProd == '' ? sNomEmp : sVersionProd;
	               		System.debug('EN validateRecords sLlaveCompuestaNombre: ' + sLlaveCompuestaNombre + ' sVersionProd: ' + sVersionProd + ' IdDealerCode__c: ' + v.IdDealerCode__c);
	               		//Crea el objeto del tipo Opportunity
						Opportunity OpportunidadPaso = new Opportunity( 
							Name = sNombreOpp,
							TAM_Vin__c = v.Name,						
							CloseDate = Date.today(),
							StageName = 'Closed Won',
							Pricebook2Id = sIdListaPrecios,
							Amount = 0.00, //dPrecio,
	        				TAM_IdExterno__c = sNombreOpp,
	        				recordTypeId = VaRtOppRegVCrm,
	        				TAM_Distribuidor__c = dealers.containsKey(v.IdDealerCode__c) ? dealers.get(v.IdDealerCode__c).id : null
						);						 
	                	System.debug('EN validateRecords OpportunidadPaso: ' + OpportunidadPaso);					
						//Agrega la al mapa de mapOppUps 
						mapOppUps.put(v.Name, OpportunidadPaso);
					}//Fin si v.Name != null
					//****** HASTA AQUI TODO ESTO PARA LOS DATOS DE LA OPOTUNIDAD ASOCIADA AL CLIENTE (Opportunity) *****///					
						
	        	}//Fin si se trata del titular


				//****** TODO ESTO PARA LOS DATOS DE LOS CONTACTOS (CONTACT) *****///
	        	//Crea la llave foranea apartir de los datos del nombre del cliente
	        	if (v.TAM_TipoCliente__c != 'Primero'){	        	
	    	    	String[] sLlaveNombreCompuestoCont = new List<String>(); 
	    	    	//v.FirstName__c, v.TAM_dNEXOS1__c, v.LastName__c, v.TAM_dNEXOS2__c, v.TAM_dAPELL2__c, 
	    	    	//	v.TAM_RFC1__c, v.TAM_RFC2__c, v.IdExterno__c
	    	    	sLlaveNombreCompuestoCont = validaNombre(v.FirstName__c, v.TAM_dNEXOS1__c, v.LastName__c, v.TAM_dNEXOS2__c, 
	    	    		v.TAM_dAPELL2__c, null, null, null); 
	
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont2: '+ sLlaveNombreCompuestoCont[0]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont2: '+ sLlaveNombreCompuestoCont[1]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont2: '+ sLlaveNombreCompuestoCont[2]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont2: '+ sLlaveNombreCompuestoCont[3]);
	                Boolean bTieneNombreContacto = false;
	                String sLlaveCompuestaNombreCont = '';
	
	                //Ve si el arreglo sLlaveNombreCompuesto tiene algo
	                if (sLlaveNombreCompuestoCont.size() > 2){
	                	//Ve si se trata de una persona Moral
	                	String sNombreCliente = sLlaveNombreCompuestoCont[0].trim();
	                	if (sNombreCliente != null && sNombreCliente != '')
	                		bTieneNombreContacto = true;
	               		sLlaveCompuestaNombreCont += sNombreCliente + ' ';
	                	sLlaveCompuestaNombreCont += sLlaveNombreCompuestoCont[1] != null && sLlaveNombreCompuestoCont[1] != '' ? sLlaveNombreCompuestoCont[1].trim() + ' ' : '';                		 	
	                	sLlaveCompuestaNombreCont += sLlaveNombreCompuestoCont[2] != null && sLlaveNombreCompuestoCont[2] != '' ? sLlaveNombreCompuestoCont[2].trim() + ' ' : '';                	
	                }//Fin si sLlaveNombreCompuesto.size() >= 2  
	                System.debug('EN validateRecords bTieneNombreContacto: ' + bTieneNombreContacto);
			                
					//Quita los espacios a los lados
					sLlaveCompuestaNombreCont = sLlaveCompuestaNombreCont.trim();
					
					//Ve si ya existe el sLlaveCompuestaNombre en el mapa de mapVinOppIdExtCliente
					mapVinOppIdExtClienteContacto.put(sLlaveCompuestaNombreCont, sLlaveCompuestaNombreCont);
					//Set<String> setErroresAccContactUps = new Set<String>();
	
					//Ve si tiene algo el campo del nombre para que puedas crear los datos del contacto
					if (bTieneNombreContacto){
	
		                System.debug('EN validateRecords sLlaveNombreCompuestoCont22: ' + sLlaveNombreCompuestoCont);

		                //Para la calle y el codigo postal
		                String sDireccionPaso = v.TAM_dTIPVIA__c != null && v.TAM_dTIPVIA__c != ' ' ? v.TAM_dTIPVIA__c.trim() + ' ' : ' ';
		                sDireccionPaso += v.TAM_ADDRESS_1__c != null && v.TAM_ADDRESS_1__c != ' ' ? v.TAM_ADDRESS_1__c.trim() + ' ' : ' ';
		                sDireccionPaso += v.TAM_dNUMEXT__c != null && v.TAM_dNUMEXT__c != ' ' ? v.TAM_dNUMEXT__c.trim() + ' ' : ' ';	                
		                sDireccionPaso += v.TAM_dNUMINT__c != null && v.TAM_dNUMINT__c != ' ' ? v.TAM_dNUMINT__c.trim() + ' ' : ' ';
		                //Para la calle y el codigo postal	                
		                String[] lDireccionPaso = sDireccionPaso.contains(';') ? sDireccionPaso.split(';') : new List<String>{sDireccionPaso};  
		                //Para la colonia
		                String sColoniaPaso = v.Address2__c != null && v.Address2__c != ' ' ? v.Address2__c.trim() + ' ' : ' '; //LISTO
		                sColoniaPaso += v.TAM_dLPOBLA__c != null && v.TAM_dLPOBLA__c != ' ' ? v.TAM_dLPOBLA__c.trim() + ' ' : ' '; //LISTO
	    	            sColoniaPaso += v.TAM_dRPOBLA__c != null && v.TAM_dRPOBLA__c != ' ' ? v.TAM_dRPOBLA__c.trim() + ' ' : ' '; //LISTO
		                //Para la ciudad 
		                String sCiudadPaso = v.City__c != null && v.City__c != '' ? v.City__c.trim() : '';
		                //Para el Estado 
		                String sEstadoPaso = v.State__c != null && v.State__c != '' ? v.State__c.trim() : '';
		                //Para el Código Postal 
		                String sCodigoPostalPaso = v.Zip__c != null && v.Zip__c != '' ? v.Zip__c.trim() : '';

		                //Para Latitud X 
		                String sdCOORGX = v.TAM_dCOORGX__c != null && v.TAM_dCOORGX__c != '' ? v.TAM_dCOORGX__c.trim() : ''; //LISTO
		                //Para Latitud Y
		                String sdCOORGY = v.TAM_dCOORGY__c != null && v.TAM_dCOORGY__c != '' ? v.TAM_dCOORGY__c.trim() : ''; //LISTO	                
		                
		                //Para el Número de Teléfono 
		                String sPhonePaso = v.TelHome__c != null && v.TelHome__c != '' ? v.TelHome__c.trim() : '';
		                //Para el Número de Teléfono del trabajo 
		                String sPhoneOfficePaso = v.TelWork__c != null && v.TelWork__c != '' ? v.TelWork__c.trim() : '';
		                //Para el Número de Teléfono del trabajo 
		                String sExtOfficePaso = v.TelWorkExt__c != null && v.TelWorkExt__c != '' ? v.TelWorkExt__c.trim() : '';
		                //Para el Correo 
		                String sEmailOfficePaso = v.Email__c != null && v.Email__c != '' ? v.Email__c.trim() : '';
		                //Para el LA FECHA DE CARGA DEL ARCHIVO 
		                //String sFechaCargaArchivo = v.Year__c != null && v.Month__c != '' && v.TAM_Day__c != null ? v.TAM_Year__c.trim() + '' + v.TAM_Month__c.trim() + '' + v.TAM_Day__c.trim() : '';
		                //Para el Genero 
		                String sGenero = v.TAM_dSEXO__c != null && v.TAM_dSEXO__c != '' ? v.TAM_dSEXO__c.trim() : '';
		                String sGeneroFinal = sGenero == 'E' ? 'Empresa' : sGenero == 'H' ? 'Masculino' : sGenero == 'M' ? 'Femenino' : null;
		                						
						//Crea el objeto del tipo Contact
						Contact ContactoPaso = new Contact(
							TAM_IdExternoNombre__c = sLlaveCompuestaNombreCont.toUpperCase() + '-' + V.Name,
							FirstName = sLlaveNombreCompuestoCont[0].toUpperCase(),
							LastName = sLlaveNombreCompuestoCont[1] != null ? sLlaveNombreCompuestoCont[1].toUpperCase() : null,
							MailingStreet = lDireccionPaso[0].toUpperCase(),
							TAM_Colonia__c = sColoniaPaso.toUpperCase(),
							MailingCity = sCiudadPaso.toUpperCase(), 
							MailingState = sEstadoPaso.toUpperCase(),
							MailingPostalCode = sCodigoPostalPaso,
							Phone = sPhonePaso,
							Extension__c = sExtOfficePaso,
							OtherPhone = sPhoneOfficePaso,						 
							CorreoElectronico__c = sEmailOfficePaso,
							Email = sEmailOfficePaso,
							recordTypeId = VaRtContRegPF,
							LeadSource = 'Ventas',
							TAM_TipoCliente__c = v.TAM_TipoCliente__c,
							MailingLongitude = sdCOORGX != '' ? Decimal.valueOf(sdCOORGX) : NULL,
							MailingLatitude = sdCOORGY != '' ? Decimal.valueOf(sdCOORGY) : NULL,
							TAM_Genero__c = sGeneroFinal
		       			);
						
		                System.debug('EN validateRecords sLlaveCompuestaNombreCont.toUpperCase(): ' + sLlaveCompuestaNombreCont.toUpperCase());						
		                System.debug('EN validateRecords ContactoPaso2: ' + ContactoPaso);
		        		//Crea el reg para la cuenta y metelo al mapa de ContactoPaso
		        		mapContactosUps.put(sLlaveCompuestaNombreCont.toUpperCase(), ContactoPaso);
						//Agrega el VIN al SET de setVinOppContact
						if (V.Name != null)
							setVinOppContact.add(V.Name);
						
					}//Fin si bTieneNombreContacto
	        	}//Segundo propietario que es un contacto asociado a la cuenta
				//****** HASTA AQUI PARA LOS DATOS DE LOS CONTACTOS (CONTACT) *****///
				        	
        	}//Fin del for para ventasList
           	System.debug('EN validateRecords mapContactosUps0: ' + mapContactosUps.keySet() + ' ' + mapContactosUps.values());
           	
           	System.debug('EN validateRecords setIdExtAccont: ' + setIdExtAccont);
           	//Consulta los clientes asociados a setIdExtAccont
           	for (Account cteExist : [Select id, TAM_IdExternoNombre__c, Name, firstName, lastName, RecordTypeId 
           	    From Account Where TAM_IdExternoNombre__c IN :setIdExtAccont]){
           		mapIdExtCteIdRtAct.put(cteExist.TAM_IdExternoNombre__c, cteExist);
           	}
           	System.debug('EN validateRecords mapIdExtCteIdRtAct: ' + mapIdExtCteIdRtAct.KeySet());
           	System.debug('EN validateRecords mapIdExtCteIdRtAct: ' + mapIdExtCteIdRtAct.Values());

           	//Recorre la lista de clientes de mapClientesUps
           	for (Account cteUpd : mapClientesUps.values()){
           		//Ver si existe cteUpd.TAM_IdExternoNombre__c en  mapIdExtCteIdRtAct
           		if (mapIdExtCteIdRtAct.containsKey(cteUpd.TAM_IdExternoNombre__c)){
		           	System.debug('EN validateRecords cteUpd.RecordTypeId0: ' + cteUpd.RecordTypeId);
           			//cteUpd.RecordTypeId = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId;
           			if (mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtAccRegPM || mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtCtePMCorp ){
                        Account ctePaso = new Account(TAM_IdExternoNombre__c = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).TAM_IdExternoNombre__c);
           			    ctePaso.firstName = null;
           			    ctePaso.lastName = null;
           			    ctePaso.Name = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).Name;
           			    if (mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtCtePMCorp)
           			          cteUpd.RecordTypeId = VaRtCtePMCorp;
                        //Agregalo al mapa de mapIdExtCteIdRtAct
                        mapClientesUps.put(cteUpd.TAM_IdExternoNombre__c, ctePaso);           			    
                        System.debug('EN validateRecords cteUpd.ctePasoM: ' + ctePaso);
           			}//Fin si cteUpd.RecordTypeId == VaRtAccRegPM
                    if (mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtAccRegPF || mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtCtePFCorp ){
                        Account ctePaso = new Account(TAM_IdExternoNombre__c = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).TAM_IdExternoNombre__c);
                        ctePaso.firstName = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).firstName;
                        ctePaso.lastName = mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).lastName;
                        if (mapIdExtCteIdRtAct.get(cteUpd.TAM_IdExternoNombre__c).RecordTypeId == VaRtCtePFCorp)
                              cteUpd.RecordTypeId = VaRtCtePFCorp;
                        //Agregalo al mapa de mapIdExtCteIdRtAct
                        mapClientesUps.put(cteUpd.TAM_IdExternoNombre__c, ctePaso);
                        System.debug('EN validateRecords cteUpd.ctePasoF: ' + ctePaso);            
                    }//Fin si cteUpd.RecordTypeId == VaRtAccRegPM
           			System.debug('EN validateRecords cteUpd.cteUpd: ' + cteUpd);   			
           		}//Fin si mapIdExtCteIdRtAct.containsKey(cteUpd.TAM_IdExternoNombre__c)
           	}//Fin drl for para los mapClientesUps
           	
           	System.debug('EN validateRecords mapClientesUps: ' + mapClientesUps.keySet());
           	System.debug('EN validateRecords mapClientesUps: ' + mapClientesUps.Values());
        	//Ya tiens los datos de las cuentas has el upsert con los datos de mapClientesUps 
        	Integer icntUpsCtes = 0;
        	if (!mapClientesUps.isEmpty()){
        		List<Account> lClientes = mapClientesUps.values();
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapClientesUps.values(), Account.TAM_IdExternoNombre__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						setErroresAccUps.add('En el cliente : ' + lClientes.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess())
						setIdCtesCreados.add(objDtbUpsRes.getId());					
					icntUpsCtes++;	
				}//Fin del for para lDtbUpsRes
        	}//Fin si mapClientesUps.isEmpty()
           	System.debug('EN validateRecords setErroresAccUps: ' + setErroresAccUps);        	
           	System.debug('EN validateRecords setIdCtesCreados: ' + setIdCtesCreados);
			//Consulta los clientes que se acaban de crear en setIdCtesCreados y metelos a mapIdClientesId
			for (Account Cliente : [Select id, TAM_IdExternoNombre__c From Account Where id IN: setIdCtesCreados]){
				mapIdClientesId.put(Cliente.TAM_IdExternoNombre__c, Cliente.id);				
			}
           	System.debug('EN validateRecords mapVinOppIdExtCliente: ' + mapVinOppIdExtCliente.keySet() + ' ' + mapVinOppIdExtCliente.values());			
           	System.debug('EN validateRecords mapIdClientesId: ' + mapIdClientesId.keySet() + ' ' + mapIdClientesId.values());			
			
			
           	System.debug('EN validateRecords mapOppUps: ' + mapOppUps.keySet() + ' ' + mapOppUps.values());
        	//Ya tiens los datos de las Opp has el upsert con los datos de mapOppUps
        	icntUpsCtes = 0;
        	if (!mapOppUps.isEmpty()){
        		Set<String> sIdExtOpp = new Set<String>();        		
        		//Inicializa una lista con las opp que se van a crear/Actualizar
        		List<Opportunity> lOppUps = mapOppUps.values();
           		System.debug('EN validateRecords lOppUps: ' + lOppUps);        		
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
        		for (Opportunity Opp : lOppUps){
        			String sNomCte = mapVinOppIdExtCliente.get(Opp.TAM_IdExterno__c);
           			System.debug('EN validateRecords sNomCte: ' + sNomCte + ' ID: ' + mapIdClientesId.get(sNomCte));        			 
        			Opp.AccountId = mapIdClientesId.get(sNomCte);
        			Opp.TAM_IdExterno__c = Opp.TAM_Vin__c + '-' + Opp.AccountId;
        			sIdExtOpp.add(Opp.TAM_IdExterno__c);
           			System.debug('EN validateRecords Opp: ' + Opp);
        		}//Fin del for para lOppUps
        		
       			System.debug('EN validateRecords sIdExtOpp: ' + sIdExtOpp);
        		Set<String> sIdExtOppExist = new Set<String>();         		
        		Set<String> sIdNoExtOppExist = new Set<String>();
        		//Consulta las Opp asociadas a los id externos de sIdExtOpp 
				for (Opportunity OppCons : [Select c.Id, c.TAM_IdExterno__c,
					(Select PricebookEntryId From OpportunityLineItems) 
					From Opportunity c Where TAM_IdExterno__c IN :sIdExtOpp]){
					//Ve si tiene productos asociados
					if (!OppCons.OpportunityLineItems.isEmpty()){	
						sIdExtOppExist.add(OppCons.TAM_IdExterno__c);
           				System.debug('EN validateRecords sIdExtOppExist: ' + OppCons.TAM_IdExterno__c);						
					}
				}//Fin del for para la lista de 
        		 
        		List<Opportunity> lOppUpsFinal = new List<Opportunity>();  
        		//Quita de la lista de lOppUps las que ya tienen un producto
        		for (Opportunity oppPaso : lOppUps){
           			System.debug('EN validateRecords oppPaso.TAM_IdExterno__c: ' + oppPaso.TAM_IdExterno__c);        			
        			//Ve si el id de la Opp TAM_IdExterno__c no esta en sIdExtOppExist, metela a una lista de paso
					if (!sIdExtOppExist.contains(oppPaso.TAM_IdExterno__c)){
						lOppUpsFinal.add(oppPaso);
						sIdNoExtOppExist.Add(oppPaso.TAM_IdExterno__c);						
					}//Fin si !sIdExtOppExist.contains(oppPaso.TAM_IdExterno__c)
        		}//Fin del for para lOppUps

       			System.debug('EN validateRecords sIdExtOppExist: ' + sIdExtOppExist);
       			System.debug('EN validateRecords sIdNoExtOppExist: ' + sIdNoExtOppExist);
       			System.debug('EN validateRecords lOppUpsFinal: ' + lOppUpsFinal.size());
       			System.debug('EN validateRecords lOppUpsFinal: ' + lOppUpsFinal);           		 
           		 
           		//Ve si tiene algo la lista de  lOppUpsFinal
           		if (!lOppUpsFinal.isEmpty()){
	        		//Actualiza las Opp 
					List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lOppUpsFinal, Opportunity.TAM_IdExterno__c, false);
					//Ve si hubo error
					for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
						if (!objDtbUpsRes.isSuccess()){
							setErroresOppUps.add('En la Opp: ' + lOppUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
           					System.debug('En la Opp: ' + lOppUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
						}//Fin si !objDtbUpsRes.isSuccess()
						if (objDtbUpsRes.isSuccess()){
							setIdOppUps.add(objDtbUpsRes.getId());
           					System.debug('EN validateRecords objDtbUpsRes.getId() Opps: ' + objDtbUpsRes.getId());							
						}
						icntUpsCtes++;	
					}//Fin del for para lDtbUpsRes
           		}//Fin si !lOppUpsFinal.isEmpty()
           		
        	}//Fin si mapOppUps.isEmpty()
           	System.debug('EN validateRecords setErroresOppUps: ' + setErroresOppUps);        	
           	System.debug('EN validateRecords setIdOppUps: ' + setIdOppUps);        	
			//Consulta las opp creadas y mete la info a un mapa de 
			for (Opportunity OppUps : [Select c.Id, c.TAM_Vin__c, c.AccountId, c.Account.IsPersonAccount, 
        		c.Account.PersonContactId From Opportunity c Where id IN:setIdOppUps]){
				mapVinOppIdUps.put(OppUps.TAM_Vin__c, OppUps);
        		if (OppUps.Account.IsPersonAccount)
        			mapIdPerAccIdContacPrinc.put(OppUps.AccountId, OppUps.Account.PersonContactId);
			}			
           	System.debug('EN validateRecords mapVinOppIdUps: ' + mapVinOppIdUps.keySet() + ' ' + mapVinOppIdUps.values());									
           	System.debug('EN validateRecords mapIdPerAccIdContacPrinc: ' + mapIdPerAccIdContacPrinc.keySet() + ' ' + mapIdPerAccIdContacPrinc.values());
           	
           	System.debug('EN validateRecords setVinOppContact: ' + setVinOppContact);           	
           	//Ve si tiene algo setVinOppContact
			if (!setVinOppContact.isEmpty()){
				for (Opportunity OppUps : [Select c.Id, c.TAM_Vin__c, c.AccountId, c.Account.IsPersonAccount, 
	        		c.Account.PersonContactId From Opportunity c Where TAM_Vin__c IN:setVinOppContact]){
					mapVinOppIdUps.put(OppUps.TAM_Vin__c, OppUps);				
					//mapVinOppIdUps.put(OppUps.TAM_Vin__c + '-' + OppUps.Account.TAM_IdExternoNombre__c, OppUps.id);
	        		if (OppUps.Account.IsPersonAccount)
	        			mapIdPerAccIdContacPrinc.put(OppUps.AccountId, OppUps.Account.PersonContactId);
				}			
	           	System.debug('EN validateRecords mapVinOppIdUps2: ' + mapVinOppIdUps.keySet() + ' ' + mapVinOppIdUps.values());									
    	       	System.debug('EN validateRecords mapIdPerAccIdContacPrinc2: ' + mapIdPerAccIdContacPrinc.keySet() + ' ' + mapIdPerAccIdContacPrinc.values());
			}//Fin si setVinOppContact.isEmpty()

           	System.debug('EN validateRecords mapContactosUps1: ' + mapContactosUps.keySet() + ' ' + mapContactosUps.values());
        	//Ya tiens los datos de las cuentas has el upsert con los datos de mapContactosUps 
        	icntUpsCtes = 0;
        	if (!mapContactosUps.isEmpty()){
        		List<Contact> lContactos = mapContactosUps.values(); 
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
        		for (Contact Contacto : lContactos){
        			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;
        			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;
        			String sIdVinPaso = sIdExtPaso.contains('-') ? sIdExtPaso.substring(sIdExtPaso.IndexOf('-')+1, sIdExtPaso.length()) : null;
		           	System.debug('EN validateRecords sNombreContact: ' + sNombreContact + ' sIdVinPaso: ' + sIdVinPaso);        			
        			//Ya tienes el VIN Asociado al contacto, busca la cuenta en el mapa de mapVinOppIdUps
        			String sIdAccount;
        			if (sIdVinPaso != null)
						sIdAccount = mapVinOppIdUps.containsKey(sIdVinPaso) ? mapVinOppIdUps.get(sIdVinPaso).AccountId : null;
		           	System.debug('EN validateRecords sIdAccount: ' + sIdAccount + ' sIdAccount: ' + sIdAccount);						
					//Ahora si actualiza el campo de TAM_IdExternoNombre__c con el ID de la cuenta
					if ( (sNombreContact != null && sIdAccount != null) || Test.isRunningTest() ){	
						//Clona el contacto 
						Contact contactoPrincipal = Contacto.clone();
						contactoPrincipal.TAM_IdExternoNombre__c =  sNombreContact + '-' + Label.TAM_IdCuentaPrincipalContactosCRM;
						contactoPrincipal.AccountId = Label.TAM_IdCuentaPrincipalContactosCRM;
						//Metelo al mapa de mapContactosUpsCtaPrinc
						mapContactosUpsCtaPrinc.put(contactoPrincipal.TAM_IdExternoNombre__c, contactoPrincipal);
					}//Fin si sNombreContact != null && sIdAccount != null
		           	//Ve que tiene el mapa de mapContactosUpsCtaPrinc
        		}//Fin del for para la lista de lContactos
	           	System.debug('EN validateRecords mapContactosUpsCtaPrinc: ' + mapContactosUpsCtaPrinc.keySet() + ' ' + mapContactosUpsCtaPrinc.values());        		
        		//Ve si tiene algo el mapa de mapContactosUpsCtaPrinc
				if (!mapContactosUpsCtaPrinc.isEmpty()){
	        		List<Contact> lContactosCtaPrinc = mapContactosUpsCtaPrinc.values();
	        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
					List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lContactosCtaPrinc, Contact.TAM_IdExternoNombre__c, false);
					//Ve si hubo error
					for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
						if (!objDtbUpsRes.isSuccess())
							setErroresContactosUps.add('En el contacto : ' + lContactosCtaPrinc.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
						if (objDtbUpsRes.isSuccess()){
							setIdContactCreados.add(objDtbUpsRes.getId());
           					System.debug('EN validateRecords objDtbUpsRes.getId() Contacts: ' + objDtbUpsRes.getId());							
						}
						icntUpsCtes++;	
					}//Fin del for para lDtbUpsRes				
				}//Fin si !mapContactosUpsCtaPrinc.isEmpty()        						
        	}//Fin si mapContactosUps.isEmpty()
           	System.debug('EN validateRecords setErroresContactosUps0: ' + setErroresContactosUps);        	
           	System.debug('EN validateRecords setIdContactCreados0: ' + setIdContactCreados);			        	
			//Consulta los clientes que se acaban de crear en setIdCtesCreados y metelos a mapIdClientesId
			for (Contact Contacto : [Select id, TAM_IdExternoNombre__c From Contact Where id IN: setIdContactCreados]){
       			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;				
	   			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;				
				mapIdContactosId.put(sNombreContact, Contacto.id);				
			}			
           	System.debug('EN validateRecords mapIdContactosId: ' + mapIdContactosId.keySet() + ' ' + mapIdContactosId.values());			
           	System.debug('EN validateRecords mapContactosUps: ' + mapContactosUps.keySet() + ' ' + mapContactosUps.values());
           	
			//Recoerre la lista de contactos que se acaban de crear y crea la relación con la cuenta principal
			//De Contactos CRM Cuenta Principal (0013F00000MzeaOQAR)
			Set<String> setTAMIdExternoACR = new Set<String>();
			for (String sIdExtrnoPaso : mapIdContactosId.keySet()){				
	           	System.debug('EN validateRecords sIdExtrnoPaso3: ' + sIdExtrnoPaso);				
				if (sIdExtrnoPaso != null){ 
					//recorre la lista de contactos de mapContactosUps.values()
	        		List<Contact> lContactos = mapContactosUps.values();					
	        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
	        		for (Contact Contacto : lContactos){
	        			Boolean bExiste = false;
	        			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;
	        			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;
	        			String sIdVinPaso = sIdExtPaso.contains('-') ? sIdExtPaso.substring(sIdExtPaso.IndexOf('-')+1, sIdExtPaso.length()) : null;
			           	System.debug('EN validateRecords sNombreContact3: ' + sNombreContact + ' sIdVinPaso: ' + sIdVinPaso);        			
	        			//Ya tienes el VIN Asociado al contacto, busca la cuenta en el mapa de mapVinOppIdUps
	        			String sIdAccount;
	        			if (sIdVinPaso != null)
							sIdAccount = mapVinOppIdUps.containsKey(sIdVinPaso) ? mapVinOppIdUps.get(sIdVinPaso).AccountId : null;
						//Ahora si actualiza el campo de TAM_IdExternoNombre__c con el ID de la cuenta
						if ( (sNombreContact != null && sIdAccount != null) || Test.isRunningTest() ){ 							
							String TAM_IdExterno = sIdExtrnoPaso + '-' + sIdAccount; 
			           		System.debug('EN validateRecords sIdAccount3: ' + sIdAccount + ' TAM_IdExterno: ' + TAM_IdExterno);
			           		System.debug('EN validateRecords sIdExtrnoPaso3: ' + sIdExtrnoPaso + ' sNombreContact: ' + sNombreContact);			           		
							//Ve si TAM_IdExterno es igual a sIdExtrnoPaso
							if (sNombreContact == sIdExtrnoPaso){
								//Busca el nombre en el mapa de mapIdContactosId
								if (mapIdContactosId.containsKey(sNombreContact)){
									//Crea el objeto del tipo AccountContactRelation
		           					AccountContactRelation AccountContactRelationPaso = new AccountContactRelation(
				       					TAM_IdExterno__c = TAM_IdExterno,
				       					ContactId = mapIdContactosId.get(sNombreContact),
				       					AccountId = sIdAccount,
				       					TAM_VIN__c = sIdVinPaso 
				       				);
		           					System.debug('EN validateRecords TAM_IdExterno: ' + TAM_IdExterno + ' AccountContactRelationPaso: ' + AccountContactRelationPaso);			       				
				       				//Agregala al mapa de mapAccountContactRelationUps
				       				mapAccountContactRelationUps.put(TAM_IdExterno, AccountContactRelationPaso);
				       				//Agrega el id externo al set de setTAMIdExternoACR
				       				setTAMIdExternoACR.add(TAM_IdExterno);
				       				bExiste = true;
								}//Fin si mapIdContactosId.containsKey(sNombreContact)
							}//Fin si TAM_IdExterno == sIdExtrnoPaso
						}//Fin si sNombreContact != null && sIdAccount != null
						//Ya lo encontramos entonces salte
						if (bExiste)
							break;
					}//Fin del for para la lContactos
       				
				}//Fin si sIdExterno != null
			}//Fin del for para la lista de mapIdContactosId.keySet()
           	System.debug('EN validateRecords mapAccountContactRelationUps: ' + mapAccountContactRelationUps.keySet());
           	System.debug('EN validateRecords mapAccountContactRelationUps: ' + mapAccountContactRelationUps.values());
			
			Set<String> setExisteACRRel = new Set<String>();
			Map<String, AccountContactRelation> mapAccountContactRelationUpsFinal = new Map<String, AccountContactRelation>();  
			//Ve si tiene algo el mapa de 
			if (!mapAccountContactRelationUps.isEmpty()){
				//Consulta todos los reg de AccountContactRelation donde el TAM_IdExterno__c este en setTAMIdExternoACR
				for (AccountContactRelation AccContRelPaso : [select id, TAM_IdExterno__c from AccountContactRelation
					where TAM_IdExterno__c IN : setTAMIdExternoACR]){
					setExisteACRRel.add(AccContRelPaso.TAM_IdExterno__c);
				}
				//Muy bien ya tienes los datos de las relaciones que existen en el set de setExisteACRRel
				//Recorre el mapa de mapAccountContactRelationUps y toma los reg que no esten en setExisteACRRel
				for (AccountContactRelation AccContRelPaso : mapAccountContactRelationUps.values()){
					//Ve si no existe AccContRelPaso.TAM_IdExterno__c  en setExisteACRRel agregalo a la lista de
					if (!setExisteACRRel.contains(AccContRelPaso.TAM_IdExterno__c))
						mapAccountContactRelationUpsFinal.put(AccContRelPaso.TAM_IdExterno__c, AccContRelPaso);
				}//Fin del for para mapAccountContactRelationUps.values()
			}//Fin si !mapAccountContactRelationUps.isEmpty()
           	System.debug('EN validateRecords mapAccountContactRelationUpsFinal: ' + mapAccountContactRelationUpsFinal.keySet());
           	System.debug('EN validateRecords mapAccountContactRelationUpsFinal: ' + mapAccountContactRelationUpsFinal.values());
		
        	icntUpsCtes = 0;			
			//Ve si tiene algo el mapa de  mapAccountContactRelationUpsFinal
			if (!mapAccountContactRelationUpsFinal.isEmpty()){
        		List<AccountContactRelation> lAccContacRel = mapAccountContactRelationUpsFinal.values();
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lAccContacRel, AccountContactRelation.TAM_IdExterno__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						setErroresAccContacRelErr.add('En AccountContactRelation : ' + lAccContacRel.get(icntUpsCtes).TAM_VIN__c + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
					if (objDtbUpsRes.isSuccess())
						setIdAccContacRelSucc.add(objDtbUpsRes.getId());					
					icntUpsCtes++;	
				}//Fin del for para lDtbUpsRes				
			}//Fin si !mapAccountContactRelationUpsFinal.isEmpty()
           	System.debug('EN validateRecords setErroresAccContacRelErr: ' + setErroresAccContacRelErr);        	
           	System.debug('EN validateRecords setIdAccContacRelSucc: ' + setIdAccContacRelSucc);	

            
        } catch(Exception ex){
            System.debug('Error upsert vines: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }

		//Un rollback para todo solo estamos en pruebas
		//Database.rollback(svUpsDatos);
        
	}

    private void actualizaDatosLead(List<TAM_VentasCRM__c> ventasList){
    
        Set<String> setIdVinActCand = new Set<String>();
        map<String, Lead> mapLeadUpsUps = new map<String, Lead>();
        Set<String> setErroresLeadErr = new Set<String>();
        Set<String> setIdLeadSucc = new Set<String>();              

        map<String, TAM_LeadInventarios__c> mapLeadInvComs = new map<String, TAM_LeadInventarios__c>();
        map<String, String> mapVinNomCte = new map<String, String>();
        map<String, TAM_LeadInventarios__c> mapLeadInvUpd = new map<String, TAM_LeadInventarios__c>();

        map<String, TAM_VentasCRM__c> mapVentasCrmCons = new map<String, TAM_VentasCRM__c>();

        //Recorre la lista de reg que se estan nsertando
        for(TAM_VentasCRM__c v: ventasList){                
            //Toma el Vin para la busqueda del candidato asociado a ese vin
            if(v.Name != null){
                setIdVinActCand.add(v.Name);
                mapVentasCrmCons.put(v.Name, v);
            }   
        }        
        System.debug('EN actualizaDatosLead setIdVinActCand: '+ setIdVinActCand);
        System.debug('EN actualizaDatosLead mapVentasCrmCons: '+ mapVentasCrmCons.KeySet());
        System.debug('EN actualizaDatosLead mapVentasCrmCons: '+ mapVentasCrmCons.Values());

        //Consulta los datos de los vines que ya estan cargados
        for (TAM_LeadInventarios__c objLeadInventarios : [Select t.id, t.TAM_VINFacturacion__c, t.TAM_Prospecto__c, t.Name 
            From TAM_LeadInventarios__c t Where (Name IN :setIdVinActCand OR TAM_VINFacturacion__c IN :setIdVinActCand)
            And TAM_Prospecto__c != null]){
            String sVinPaso = objLeadInventarios.Name;
            Lead CandUpd = new Lead(
                id = objLeadInventarios.TAM_Prospecto__c, TAM_PedidoReportado__c = true, 
                Status = 'Entregado', FWY_Estado_del_candidatoWEB__c = 'Entregado', 
                TAM_PorcentajeAvance__c = '100%', 
                TAM_FechaEntrega__c = mapVentasCrmCons.get(sVinPaso).SubmittedDate__c 
            );
            //mete los datos en el mapa de mapIdInveCand para mandar llamar el proceso ActualizaVinCandito
            mapLeadUpsUps.put(objLeadInventarios.TAM_Prospecto__c, CandUpd);     
            mapLeadInvComs.put(objLeadInventarios.Name, objLeadInventarios);
            if (objLeadInventarios.TAM_VINFacturacion__c != null)
                mapLeadInvComs.put(objLeadInventarios.TAM_VINFacturacion__c, objLeadInventarios);
        }    
        System.debug('EN actualizaDatosLead mapLeadUpsUps: '+ mapLeadUpsUps);
        System.debug('EN actualizaDatosLead mapLeadInvComs: '+ mapLeadInvComs);

        //Ve si tiene algo el mapa de  mapLeadUpsUps             
        //mapLeadInvComs.put(objLeadInventarios.id, objLeadInventarios);
        if (!mapLeadUpsUps.isEmpty()){
                
           //Consulta los datos de los clientes asociados a los veines de mapLeadInvComs.KeySet()
           for (Opportunity opp : [Select id, Account.Name, Account.TAM_IdExternoNombre__c, TAM_Vin__c 
               From Opportunity Where TAM_Vin__c IN :mapLeadInvComs.KeySet()]){
               String sNameCte = opp.Account.TAM_IdExternoNombre__c != null ? opp.Account.TAM_IdExternoNombre__c : opp.Account.Name;
               //Agregalo a la mapa de mapVinNomCte
               mapVinNomCte.put(opp.TAM_Vin__c, sNameCte);
           }
           System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapVinNomCte.KeySet());         
           System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapVinNomCte.Values()); 
                                
           List<Lead> lLeadUpd = mapLeadUpsUps.values();
           //Recorre la lista de lLeadUpd y actualiza el campo de TAM_NombreClienteHistorico__c
           for (Lead CandUpd : lLeadUpd){
                //Busca el lead en el mapa de mapLeadInvComs
                if (mapLeadUpsUps.containsKey(CandUpd.id)){
                   String sVinLead = '';
                   String sVinLeadFact = '';
                   //Toma el nombre del objeto  objLeadInventarios
                   for (TAM_LeadInventarios__c objLeadInv : mapLeadInvComs.Values()){
                        if (objLeadInv.TAM_Prospecto__c == CandUpd.id){
                            sVinLead = objLeadInv.Name;
                            sVinLeadFact = objLeadInv.TAM_VINFacturacion__c != null ? objLeadInv.TAM_VINFacturacion__c : objLeadInv.Name;
                            break;
                        }//Fin si objLeadInv.TAM_Prospecto__c == CandUpd.id
                   }//Fin si 
                   TAM_LeadInventarios__c objLeadInvUpd;
                   //Busca el cliente asociado a sVinLead o sVinLeadFact
                   if (mapVinNomCte.containsKey(sVinLead)){ 
                        objLeadInvUpd = new TAM_LeadInventarios__c(id = mapLeadInvComs.get(sVinLead).id);
                        objLeadInvUpd.TAM_NombreClienteHistorico__c = mapVinNomCte.get(sVinLead);
                   }//Fin si mapVinNomCte.containsKey(sVinLeadFact)
                   if (!mapVinNomCte.containsKey(sVinLeadFact)) {
                      if (mapVinNomCte.containsKey(sVinLeadFact)){ 
                          objLeadInvUpd = new TAM_LeadInventarios__c(id = mapLeadInvComs.get(sVinLeadFact).id);
                          objLeadInvUpd.TAM_NombreClienteHistorico__c = mapVinNomCte.get(sVinLeadFact);
                      }//Fin si mapVinNomCte.containsKey(sVinLeadFact)
                   }//Fin si mapVinNomCte.containsKey(sVinLeadFact)
                   System.debug('EN actualizaDatosLead objLeadInvUpd: ' + objLeadInvUpd);
                   //Ve si tiene algo el obj de objLeadInvUpd
                   if (objLeadInvUpd != null)
                      mapLeadInvUpd.put(objLeadInvUpd.id, objLeadInvUpd);  
                }//Fin si mapLeadInvComs.containsKey(CandUpd.id)
           }//Fin del for para lLeadUpd
                
           Integer icntUpsCtes = 0;
           //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
           List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lLeadUpd, Lead.id, false);
           //Ve si hubo error
           for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
               if (!objDtbUpsRes.isSuccess())
                   setErroresLeadErr.add('En Lead : ' + lLeadUpd.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
               icntUpsCtes++;  
           }//Fin del for para lDtbUpsRes              

           icntUpsCtes = 0;
           //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
           List<Database.Upsertresult> lDtbLiUpsRes = Database.upsert(mapLeadInvUpd.values(), TAM_LeadInventarios__c.id, false);
           //Ve si hubo error
           for (Database.Upsertresult objDtbUpsRes : lDtbLiUpsRes){
               if (!objDtbUpsRes.isSuccess())
                  setErroresLeadErr.add('En Lead : ' + mapLeadInvUpd.values().get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
               icntUpsCtes++;  
           }//Fin del for para lDtbLiUpsRes              

        }//Fin si !mapLeadUpsUps.isEmpty()
        System.debug('EN actualizaDatosLead setErroresLeadErr: ' + setErroresLeadErr);         
        System.debug('EN actualizaDatosLead setIdLeadSucc: ' + setIdLeadSucc);
    
    }

    private String[] validaNombre(String FirstName, String sdNEXOS1, String LastName, String sdNEXOS2, String sdAPELL2,
    	String RFC, String RFC2, String IdExterno){
    	System.debug('Entro a validaNombre FirstName: ' + FirstName + ' sdNEXOS1: ' + sdNEXOS1 + ' LastName: ' + LastName + ' sdNEXOS2: ' + sdNEXOS2 + ' sdAPELL2: ' + sdAPELL2 + ' RFC: ' + RFC + ' RFC2: ' + RFC2 + ' IdExterno: ' + IdExterno);    	 
    	String[] sNombreValido = new String[5];
    	
        try{
         	
	    	Integer iCnt = 0;
	    	Set<String> setAcentos = new Set<String>{'Á','É','Í','Ó','Ú'};
	    	List<String> lSinAcento = new List<String>{'A','E','I','O','U'};    	
	    	String sFirstName = FirstName != null ? FirstName.trim().toUpperCase() : '';
	    	
	    	String ssdNEXOS1 = sdNEXOS1 != null ? sdNEXOS1.trim().toUpperCase() : '';
	    	String sLastName = LastName != null ? LastName.trim().toUpperCase() : '';
	    	
	   		String sApellidoPaterno = ssdNEXOS1 + ' ' + sLastName; 	
	    	
	    	String ssdNEXOS2 = sdNEXOS2 != null ? sdNEXOS2.trim().toUpperCase() : '';
	    	String ssdAPELL2 = sdAPELL2 != null ? sdAPELL2.trim().toUpperCase() : '';
	    	
	   		String sApellidoMaterno = ssdNEXOS2 + ' ' + ssdAPELL2; 		    	
	    	
	    	String sRFC = RFC != null ? RFC.trim().toUpperCase() : '';
	    	String sRFC2 = RFC2 != null ? RFC2.trim().toUpperCase() : '';
	    	String sIdExterno = IdExterno!= null ? IdExterno.trim().toUpperCase() : '';

			for (String sAcento : setAcentos){
				sFirstName = sFirstName.replaceAll(sAcento, lSinAcento.get(iCnt));				
				sApellidoPaterno = sApellidoPaterno.replaceAll(sAcento, lSinAcento.get(iCnt));
				sApellidoMaterno = sApellidoMaterno.replaceAll(sAcento, lSinAcento.get(iCnt));
				iCnt++;
			}	
	    	System.debug('Entro a validaNombre sFirstName: ' + sFirstName + ' sApellidoPaterno: ' + sApellidoPaterno + ' sApellidoMaterno: ' + sApellidoMaterno);
			
			//Valida los datos para ordenar los campos
			if ( (sApellidoPaterno.trim() == null || sApellidoPaterno.trim() == '') && (sApellidoMaterno.trim() == null || sApellidoMaterno.trim() == '') ){
				//Quita los espcios en blanco que vengan enmdio del nombre
				String sPasoFirstName = sFirstName.replaceAll('   ', ' ').replaceAll('  ', ' ');
				sNombreValido[0] = '';
				sNombreValido[1] = sPasoFirstName;
				sNombreValido[2] = '';
		    	System.debug('Entro a validaNombre VAL PM sNombreValido: ' + sNombreValido);
				
			}//Fin si  (sApellidoPaterno == null || sApellidoPaterno == '') && (sApellidoMaterno == null || sApellidoMaterno == '')
			else if ( (sApellidoPaterno.trim() != null && sApellidoPaterno.trim() != '') || (sApellidoMaterno.trim() != null || sApellidoMaterno.trim() != '') ){
				String sPasoFirstName = sFirstName.replaceAll('   ', ' ').replaceAll('  ', ' ');
				String sPasoApellidoPaterno = sApellidoPaterno.replaceAll('   ', ' ').replaceAll('  ', ' ');
				String sPasoApellidoMaterno = sApellidoMaterno.replaceAll('   ', ' ').replaceAll('  ', ' ');
				sNombreValido[0] = sFirstName;
				sNombreValido[1] = sPasoApellidoPaterno;
				sNombreValido[2] = sPasoApellidoMaterno;
		    	System.debug('Entro a validaNombre VAL PF sNombreValido: ' + sNombreValido);

			}//Fin si  (sApellidoPaterno != null && sApellidoPaterno != '') || (sApellidoMaterno != null || sApellidoMaterno != '')	    	

        }catch(Exception ex){
            System.debug('Error en validaNombre detalle: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }
		
		//Regresa el nombre como llave    	    	
    	return sNombreValido;
    }    
    
}